diff --git a/gcc/config/rs6000/rs6000.c b/gcc/config/rs6000/rs6000.c
index 132a202..c5f86d0 100644
--- a/gcc/config/rs6000/rs6000.c
+++ b/gcc/config/rs6000/rs6000.c
@@ -24221,7 +24221,16 @@ rs6000_emit_stack_tie (rtx fp, bool hard_frame_needed)
 	    && REGNO (fp) == HARD_FRAME_POINTER_REGNUM)))
     regs[i++] = fp;
 
-  p = rtvec_alloc (i);
+  /* Unfortunately, the effect of prologue and epilogue insn is mostly ignored
+     from init_alias_analysis, and this is problematic with respect to our
+     temporary use of regular registers to address the frame (as conveyed by
+     our FP argument).  We have to resort to a non-subtle memory blockage
+     mechanism until this is resolved.  */
+
+  p = rtvec_alloc (i+1);
+  RTVEC_ELT (p, i) = 
+    gen_rtx_CLOBBER (VOIDmode, gen_rtx_MEM (BLKmode, gen_rtx_SCRATCH (Pmode)));
+
   while (--i >= 0)
     {
       rtx mem = gen_frame_mem (BLKmode, regs[i]);
